from ..utils import applier, replacer

EXCEPTIONS_SQCQ = {
    "БАТЮЩИН": "БАТЮШЧИН",
    "ПЛЯЩИН": "ПЛЯШЧИН",
    "ПОДУЩАН": "ПОДУШЧАН",
    "ШАРАЩИН": "ШАРАШЧИН",
    "МЕЛАЩИН": "МЕЛАШЧИН",
}

EXCEPTIONS_JI = [
    "НАЇБ",
    "НАЇБА",
    "НАЇБАМ",
    "НАЇБАМИ",
    "НАЇБАХ",
    "НАЇБЕ",
    "НАЇБИ",
    "НАЇБІ",
    "НАЇБІВ",
    "НАЇБОВІ",
    "НАЇБОМ",
    "НАЇБСТВА",
    "НАЇБСТВІ",
    "НАЇБСТВО",
    "НАЇБСТВОМ",
    "НАЇБСТВУ",
    "НАЇБУ",
    "НАЇВ",
    "НАЇВНА",
    "НАЇВНАЯ",
    "НАЇВНЕ",
    "НАЇВНЕЄ",
    "НАЇВНЕНЬКА",
    "НАЇВНЕНЬКЕ",
    "НАЇВНЕНЬКИЙ",
    "НАЇВНЕНЬКИМ",
    "НАЇВНЕНЬКИМИ",
    "НАЇВНЕНЬКИХ",
    "НАЇВНЕНЬКІ",
    "НАЇВНЕНЬКІЙ",
    "НАЇВНЕНЬКІМ",
    "НАЇВНЕНЬКОГО",
    "НАЇВНЕНЬКОЇ",
    "НАЇВНЕНЬКОМУ",
    "НАЇВНЕНЬКОЮ",
    "НАЇВНЕНЬКУ",
    "НАЇВНИЙ",
    "НАЇВНИМ",
    "НАЇВНИМИ",
    "НАЇВНИХ",
    "НАЇВНІ",
    "НАЇВНІЇ",
    "НАЇВНІЙ",
    "НАЇВНІМ",
    "НАЇВНІСТЬ",
    "НАЇВНІСТЮ",
    "НАЇВНІШ",
    "НАЇВНІША",
    "НАЇВНІШАЯ",
    "НАЇВНІШЕ",
    "НАЇВНІШЕЄ",
    "НАЇВНІШИЙ",
    "НАЇВНІШИМ",
    "НАЇВНІШИМИ",
    "НАЇВНІШИХ",
    "НАЇВНІШІ",
    "НАЇВНІШІЇ",
    "НАЇВНІШІЙ",
    "НАЇВНІШІМ",
    "НАЇВНІШОГО",
    "НАЇВНІШОЇ",
    "НАЇВНІШОМУ",
    "НАЇВНІШОЮ",
    "НАЇВНІШУ",
    "НАЇВНІШУЮ",
    "НАЇВНО",
    "НАЇВНОГО",
    "НАЇВНОЇ",
    "НАЇВНОМУ",
    "НАЇВНОСТЕ",
    "НАЇВНОСТЕЙ",
    "НАЇВНОСТИ",
    "НАЇВНОСТІ",
    "НАЇВНОСТЯМ",
    "НАЇВНОСТЯМИ",
    "НАЇВНОСТЯХ",
    "НАЇВНОЮ",
    "НАЇВНУ",
    "НАЇВНУЮ",
    "НАЇВНЯК",
    "НАЇВНЯКА",
    "НАЇВНЯКАМ",
    "НАЇВНЯКАМИ",
    "НАЇВНЯКАХ",
    "НАЇВНЯКИ",
    "НАЇВНЯКІВ",
    "НАЇВНЯКОВІ",
    "НАЇВНЯКОМ",
    "НАЇВНЯКУ",
    "НАЇВНЯЦЬКА",
    "НАЇВНЯЦЬКЕ",
    "НАЇВНЯЦЬКИЙ",
    "НАЇВНЯЦЬКИМ",
    "НАЇВНЯЦЬКИМИ",
    "НАЇВНЯЦЬКИХ",
    "НАЇВНЯЦЬКІ",
    "НАЇВНЯЦЬКІЙ",
    "НАЇВНЯЦЬКІМ",
    "НАЇВНЯЦЬКОГО",
    "НАЇВНЯЦЬКОЇ",
    "НАЇВНЯЦЬКОМУ",
    "НАЇВНЯЦЬКОЮ",
    "НАЇВНЯЦЬКУ",
    "НАЇВСЬ",
    "НАЇВСЯ",
    "НАЇВШИ",
    "НАЇВШИСЬ",
    "НАЇВШИСЯ",
    "НАЇДАВ",
    "НАЇДАВСЬ",
    "НАЇДАВСЯ",
    "НАЇДАВШИ",
    "НАЇДАВШИСЬ",
    "НАЇДАВШИСЯ",
    "НАЇДАЄ",
    "НАЇДАЄМ",
    "НАЇДАЄМО",
    "НАЇДАЄМОСЬ",
    "НАЇДАЄМОСЯ",
    "НАЇДАЄМСЯ",
    "НАЇДАЄТЕ",
    "НАЇДАЄТЕСЬ",
    "НАЇДАЄТЕСЯ",
    "НАЇДАЄТЬСЯ",
    "НАЇДАЄШ",
    "НАЇДАЄШСЯ",
    "НАЇДАЙ",
    "НАЇДАЙМО",
    "НАЇДАЙМОСЬ",
    "НАЇДАЙМОСЯ",
    "НАЇДАЙСЬ",
    "НАЇДАЙСЯ",
    "НАЇДАЙТЕ",
    "НАЇДАЙТЕСЬ",
    "НАЇДАЙТЕСЯ",
    "НАЇДАЛА",
    "НАЇДАЛАСЬ",
    "НАЇДАЛАСЯ",
    "НАЇДАЛИ",
    "НАЇДАЛИСЬ",
    "НАЇДАЛИСЯ",
    "НАЇДАЛО",
    "НАЇДАЛОСЬ",
    "НАЇДАЛОСЯ",
    "НАЇДАННІ",
    "НАЇДАННЮ",
    "НАЇДАННЯ",
    "НАЇДАННЯМ",
    "НАЇДАТИ",
    "НАЇДАТИМЕ",
    "НАЇДАТИМЕМ",
    "НАЇДАТИМЕМО",
    "НАЇДАТИМЕМОСЬ",
    "НАЇДАТИМЕМОСЯ",
    "НАЇДАТИМЕМСЯ",
    "НАЇДАТИМЕТЕ",
    "НАЇДАТИМЕТЕСЬ",
    "НАЇДАТИМЕТЕСЯ",
    "НАЇДАТИМЕТЬСЯ",
    "НАЇДАТИМЕШ",
    "НАЇДАТИМЕШСЯ",
    "НАЇДАТИМУ",
    "НАЇДАТИМУСЬ",
    "НАЇДАТИМУСЯ",
    "НАЇДАТИМУТЬ",
    "НАЇДАТИМУТЬСЯ",
    "НАЇДАТИСЬ",
    "НАЇДАТИСЯ",
    "НАЇДАТЬ",
    "НАЇДАТЬСЯ",
    "НАЇДАЮ",
    "НАЇДАЮСЬ",
    "НАЇДАЮСЯ",
    "НАЇДАЮТЬ",
    "НАЇДАЮТЬСЯ",
    "НАЇДАЮЧИ",
    "НАЇДАЮЧИСЬ",
    "НАЇДАЮЧИСЯ",
    "НАЇДЕ",
    "НАЇДЕМ",
    "НАЇДЕМО",
    "НАЇДЕНА",
    "НАЇДЕНЕ",
    "НАЇДЕНИЙ",
    "НАЇДЕНИМ",
    "НАЇДЕНИМИ",
    "НАЇДЕНИХ",
    "НАЇДЕНІ",
    "НАЇДЕНІЙ",
    "НАЇДЕНІМ",
    "НАЇДЕНОГО",
    "НАЇДЕНОЇ",
    "НАЇДЕНОМУ",
    "НАЇДЕНОЮ",
    "НАЇДЕНУ",
    "НАЇДЕТЕ",
    "НАЇДЕШ",
    "НАЇДЖЕНА",
    "НАЇДЖЕНЕ",
    "НАЇДЖЕНИЙ",
    "НАЇДЖЕНИМ",
    "НАЇДЖЕНИМИ",
    "НАЇДЖЕНИХ",
    "НАЇДЖЕНІ",
    "НАЇДЖЕНІЙ",
    "НАЇДЖЕНІМ",
    "НАЇДЖЕНОГО",
    "НАЇДЖЕНОЇ",
    "НАЇДЖЕНОМУ",
    "НАЇДЖЕНОЮ",
    "НАЇДЖЕНУ",
    "НАЇДКАМ",
    "НАЇДКАМИ",
    "НАЇДКАХ",
    "НАЇДКИ",
    "НАЇДКІВ",
    "НАЇДКОВІ",
    "НАЇДКОМ",
    "НАЇДКУ",
    "НАЇДОК",
    "НАЇДУ",
    "НАЇДУТЬ",
    "НАЇДЬ",
    "НАЇДЬМО",
    "НАЇДЬТЕ",
    "НАЇДЯТЬ",
    "НАЇДЯТЬСЯ",
    "НАЇЖ",
    "НАЇЖАТЬ",
    "НАЇЖАТЬСЯ",
    "НАЇЖАЧ",
    "НАЇЖАЧАТЬ",
    "НАЇЖАЧАТЬСЯ",
    "НАЇЖАЧЕНА",
    "НАЇЖАЧЕНЕ",
    "НАЇЖАЧЕНИЙ",
    "НАЇЖАЧЕНИМ",
    "НАЇЖАЧЕНИМИ",
    "НАЇЖАЧЕНИХ",
    "НАЇЖАЧЕНІ",
    "НАЇЖАЧЕНІЙ",
    "НАЇЖАЧЕНІМ",
    "НАЇЖАЧЕНІСТЬ",
    "НАЇЖАЧЕНІСТЮ",
    "НАЇЖАЧЕНО",
    "НАЇЖАЧЕНОГО",
    "НАЇЖАЧЕНОЇ",
    "НАЇЖАЧЕНОМУ",
    "НАЇЖАЧЕНОСТЕ",
    "НАЇЖАЧЕНОСТИ",
    "НАЇЖАЧЕНОСТІ",
    "НАЇЖАЧЕНОЮ",
    "НАЇЖАЧЕНУ",
    "НАЇЖАЧИВ",
    "НАЇЖАЧИВСЬ",
    "НАЇЖАЧИВСЯ",
    "НАЇЖАЧИВШИ",
    "НАЇЖАЧИВШИСЬ",
    "НАЇЖАЧИВШИСЯ",
    "НАЇЖАЧИЛА",
    "НАЇЖАЧИЛАСЬ",
    "НАЇЖАЧИЛАСЯ",
    "НАЇЖАЧИЛИ",
    "НАЇЖАЧИЛИСЬ",
    "НАЇЖАЧИЛИСЯ",
    "НАЇЖАЧИЛО",
    "НАЇЖАЧИЛОСЬ",
    "НАЇЖАЧИЛОСЯ",
    "НАЇЖАЧИМ",
    "НАЇЖАЧИМО",
    "НАЇЖАЧИМОСЬ",
    "НАЇЖАЧИМОСЯ",
    "НАЇЖАЧИМСЯ",
    "НАЇЖАЧИТЕ",
    "НАЇЖАЧИТЕСЬ",
    "НАЇЖАЧИТЕСЯ",
    "НАЇЖАЧИТИ",
    "НАЇЖАЧИТИСЬ",
    "НАЇЖАЧИТИСЯ",
    "НАЇЖАЧИТЬ",
    "НАЇЖАЧИТЬСЯ",
    "НАЇЖАЧИШ",
    "НАЇЖАЧИШСЯ",
    "НАЇЖАЧМО",
    "НАЇЖАЧМОСЬ",
    "НАЇЖАЧМОСЯ",
    "НАЇЖАЧСЯ",
    "НАЇЖАЧТЕ",
    "НАЇЖАЧТЕСЬ",
    "НАЇЖАЧТЕСЯ",
    "НАЇЖАЧУ",
    "НАЇЖАЧУВАВ",
    "НАЇЖАЧУВАВСЬ",
    "НАЇЖАЧУВАВСЯ",
    "НАЇЖАЧУВАВШИ",
    "НАЇЖАЧУВАВШИСЬ",
    "НАЇЖАЧУВАВШИСЯ",
    "НАЇЖАЧУВАЛА",
    "НАЇЖАЧУВАЛАСЬ",
    "НАЇЖАЧУВАЛАСЯ",
    "НАЇЖАЧУВАЛИ",
    "НАЇЖАЧУВАЛИСЬ",
    "НАЇЖАЧУВАЛИСЯ",
    "НАЇЖАЧУВАЛО",
    "НАЇЖАЧУВАЛОСЬ",
    "НАЇЖАЧУВАЛОСЯ",
    "НАЇЖАЧУВАТИ",
    "НАЇЖАЧУВАТИМЕ",
    "НАЇЖАЧУВАТИМЕМ",
    "НАЇЖАЧУВАТИМЕМО",
    "НАЇЖАЧУВАТИМЕМОСЬ",
    "НАЇЖАЧУВАТИМЕМОСЯ",
    "НАЇЖАЧУВАТИМЕМСЯ",
    "НАЇЖАЧУВАТИМЕТЕ",
    "НАЇЖАЧУВАТИМЕТЕСЬ",
    "НАЇЖАЧУВАТИМЕТЕСЯ",
    "НАЇЖАЧУВАТИМЕТЬСЯ",
    "НАЇЖАЧУВАТИМЕШ",
    "НАЇЖАЧУВАТИМЕШСЯ",
    "НАЇЖАЧУВАТИМУ",
    "НАЇЖАЧУВАТИМУСЬ",
    "НАЇЖАЧУВАТИМУСЯ",
    "НАЇЖАЧУВАТИМУТЬ",
    "НАЇЖАЧУВАТИМУТЬСЯ",
    "НАЇЖАЧУВАТИСЬ",
    "НАЇЖАЧУВАТИСЯ",
    "НАЇЖАЧУВАТЬ",
    "НАЇЖАЧУВАТЬСЯ",
    "НАЇЖАЧУЄ",
    "НАЇЖАЧУЄМ",
    "НАЇЖАЧУЄМО",
    "НАЇЖАЧУЄМОСЬ",
    "НАЇЖАЧУЄМОСЯ",
    "НАЇЖАЧУЄМСЯ",
    "НАЇЖАЧУЄТЕ",
    "НАЇЖАЧУЄТЕСЬ",
    "НАЇЖАЧУЄТЕСЯ",
    "НАЇЖАЧУЄТЬСЯ",
    "НАЇЖАЧУЄШ",
    "НАЇЖАЧУЄШСЯ",
    "НАЇЖАЧУЙ",
    "НАЇЖАЧУЙМО",
    "НАЇЖАЧУЙМОСЬ",
    "НАЇЖАЧУЙМОСЯ",
    "НАЇЖАЧУЙСЬ",
    "НАЇЖАЧУЙСЯ",
    "НАЇЖАЧУЙТЕ",
    "НАЇЖАЧУЙТЕСЬ",
    "НАЇЖАЧУЙТЕСЯ",
    "НАЇЖАЧУСЬ",
    "НАЇЖАЧУСЯ",
    "НАЇЖАЧУЮ",
    "НАЇЖАЧУЮСЬ",
    "НАЇЖАЧУЮСЯ",
    "НАЇЖАЧУЮТЬ",
    "НАЇЖАЧУЮТЬСЯ",
    "НАЇЖАЧУЮЧИ",
    "НАЇЖАЧУЮЧИСЬ",
    "НАЇЖАЧУЮЧИСЯ",
    "НАЇЖДЖА",
    "НАЇЖДЖАВ",
    "НАЇЖДЖАВШИ",
    "НАЇЖДЖАЄ",
    "НАЇЖДЖАЄМ",
    "НАЇЖДЖАЄМО",
    "НАЇЖДЖАЄТЕ",
    "НАЇЖДЖАЄШ",
    "НАЇЖДЖАЙ",
    "НАЇЖДЖАЙМО",
    "НАЇЖДЖАЙТЕ",
    "НАЇЖДЖАЛА",
    "НАЇЖДЖАЛИ",
    "НАЇЖДЖАЛО",
    "НАЇЖДЖАННІ",
    "НАЇЖДЖАННЮ",
    "НАЇЖДЖАННЯ",
    "НАЇЖДЖАННЯМ",
    "НАЇЖДЖАТИ",
    "НАЇЖДЖАТИМЕ",
    "НАЇЖДЖАТИМЕМ",
    "НАЇЖДЖАТИМЕМО",
    "НАЇЖДЖАТИМЕТЕ",
    "НАЇЖДЖАТИМЕШ",
    "НАЇЖДЖАТИМУ",
    "НАЇЖДЖАТИМУТЬ",
    "НАЇЖДЖАТЬ",
    "НАЇЖДЖАЮ",
    "НАЇЖДЖАЮТЬ",
    "НАЇЖДЖАЮЧА",
    "НАЇЖДЖАЮЧЕ",
    "НАЇЖДЖАЮЧИ",
    "НАЇЖДЖАЮЧИЙ",
    "НАЇЖДЖАЮЧИМ",
    "НАЇЖДЖАЮЧИМИ",
    "НАЇЖДЖАЮЧИХ",
    "НАЇЖДЖАЮЧІ",
    "НАЇЖДЖАЮЧІЙ",
    "НАЇЖДЖАЮЧІМ",
    "НАЇЖДЖАЮЧОГО",
    "НАЇЖДЖАЮЧОЇ",
    "НАЇЖДЖАЮЧОМУ",
    "НАЇЖДЖАЮЧОЮ",
    "НАЇЖДЖАЮЧУ",
    "НАЇЖДЖЕ",
    "НАЇЖДЖЕНА",
    "НАЇЖДЖЕНЕ",
    "НАЇЖДЖЕНИЙ",
    "НАЇЖДЖЕНИМ",
    "НАЇЖДЖЕНИМИ",
    "НАЇЖДЖЕНИХ",
    "НАЇЖДЖЕНІ",
    "НАЇЖДЖЕНІЙ",
    "НАЇЖДЖЕНІМ",
    "НАЇЖДЖЕНО",
    "НАЇЖДЖЕНОГО",
    "НАЇЖДЖЕНОЇ",
    "НАЇЖДЖЕНОМУ",
    "НАЇЖДЖЕНОЮ",
    "НАЇЖДЖЕНУ",
    "НАЇЖДЖИЙ",
    "НАЇЖДЖИМ",
    "НАЇЖДЖИМИ",
    "НАЇЖДЖИХ",
    "НАЇЖДЖІ",
    "НАЇЖДЖІЙ",
    "НАЇЖДЖІМ",
    "НАЇЖДЖОГО",
    "НАЇЖДЖОЇ",
    "НАЇЖДЖОМУ",
    "НАЇЖДЖОЮ",
    "НАЇЖДЖУ",
    "НАЇЖДЖУСЬ",
    "НАЇЖДЖУСЯ",
    "НАЇЖЕНА",
    "НАЇЖЕНЕ",
    "НАЇЖЕНИЙ",
    "НАЇЖЕНИМ",
    "НАЇЖЕНИМИ",
    "НАЇЖЕНИХ",
    "НАЇЖЕНІ",
    "НАЇЖЕНІЙ",
    "НАЇЖЕНІМ",
    "НАЇЖЕНІСТЬ",
    "НАЇЖЕНІСТЮ",
    "НАЇЖЕНОГО",
    "НАЇЖЕНОЇ",
    "НАЇЖЕНОМУ",
    "НАЇЖЕНОСТЕ",
    "НАЇЖЕНОСТИ",
    "НАЇЖЕНОСТІ",
    "НАЇЖЕНОЮ",
    "НАЇЖЕНУ",
    "НАЇЖИВ",
    "НАЇЖИВСЬ",
    "НАЇЖИВСЯ",
    "НАЇЖИВШИ",
    "НАЇЖИВШИСЬ",
    "НАЇЖИВШИСЯ",
    "НАЇЖИЛА",
    "НАЇЖИЛАСЬ",
    "НАЇЖИЛАСЯ",
    "НАЇЖИЛИ",
    "НАЇЖИЛИСЬ",
    "НАЇЖИЛИСЯ",
    "НАЇЖИЛО",
    "НАЇЖИЛОСЬ",
    "НАЇЖИЛОСЯ",
    "НАЇЖИМ",
    "НАЇЖИМО",
    "НАЇЖИМОСЬ",
    "НАЇЖИМОСЯ",
    "НАЇЖИМСЯ",
    "НАЇЖИТЕ",
    "НАЇЖИТЕСЬ",
    "НАЇЖИТЕСЯ",
    "НАЇЖИТИ",
    "НАЇЖИТИСЬ",
    "НАЇЖИТИСЯ",
    "НАЇЖИТЬ",
    "НАЇЖИТЬСЯ",
    "НАЇЖИШ",
    "НАЇЖИШСЯ",
    "НАЇЖМО",
    "НАЇЖМОСЬ",
    "НАЇЖМОСЯ",
    "НАЇЖСЯ",
    "НАЇЖТЕ",
    "НАЇЖТЕСЬ",
    "НАЇЖТЕСЯ",
    "НАЇЖУ",
    "НАЇЖУВАВ",
    "НАЇЖУВАВСЬ",
    "НАЇЖУВАВСЯ",
    "НАЇЖУВАВШИ",
    "НАЇЖУВАВШИСЬ",
    "НАЇЖУВАВШИСЯ",
    "НАЇЖУВАЛА",
    "НАЇЖУВАЛАСЬ",
    "НАЇЖУВАЛАСЯ",
    "НАЇЖУВАЛИ",
    "НАЇЖУВАЛИСЬ",
    "НАЇЖУВАЛИСЯ",
    "НАЇЖУВАЛО",
    "НАЇЖУВАЛОСЬ",
    "НАЇЖУВАЛОСЯ",
    "НАЇЖУВАТИ",
    "НАЇЖУВАТИМЕ",
    "НАЇЖУВАТИМЕМ",
    "НАЇЖУВАТИМЕМО",
    "НАЇЖУВАТИМЕМОСЬ",
    "НАЇЖУВАТИМЕМОСЯ",
    "НАЇЖУВАТИМЕМСЯ",
    "НАЇЖУВАТИМЕТЕ",
    "НАЇЖУВАТИМЕТЕСЬ",
    "НАЇЖУВАТИМЕТЕСЯ",
    "НАЇЖУВАТИМЕТЬСЯ",
    "НАЇЖУВАТИМЕШ",
    "НАЇЖУВАТИМЕШСЯ",
    "НАЇЖУВАТИМУ",
    "НАЇЖУВАТИМУСЬ",
    "НАЇЖУВАТИМУСЯ",
    "НАЇЖУВАТИМУТЬ",
    "НАЇЖУВАТИМУТЬСЯ",
    "НАЇЖУВАТИСЬ",
    "НАЇЖУВАТИСЯ",
    "НАЇЖУВАТЬ",
    "НАЇЖУВАТЬСЯ",
    "НАЇЖУЄ",
    "НАЇЖУЄМ",
    "НАЇЖУЄМО",
    "НАЇЖУЄМОСЬ",
    "НАЇЖУЄМОСЯ",
    "НАЇЖУЄМСЯ",
    "НАЇЖУЄТЕ",
    "НАЇЖУЄТЕСЬ",
    "НАЇЖУЄТЕСЯ",
    "НАЇЖУЄТЬСЯ",
    "НАЇЖУЄШ",
    "НАЇЖУЄШСЯ",
    "НАЇЖУЙ",
    "НАЇЖУЙМО",
    "НАЇЖУЙМОСЬ",
    "НАЇЖУЙМОСЯ",
    "НАЇЖУЙСЬ",
    "НАЇЖУЙСЯ",
    "НАЇЖУЙТЕ",
    "НАЇЖУЙТЕСЬ",
    "НАЇЖУЙТЕСЯ",
    "НАЇЖУСЬ",
    "НАЇЖУСЯ",
    "НАЇЖУЮ",
    "НАЇЖУЮСЬ",
    "НАЇЖУЮСЯ",
    "НАЇЖУЮТЬ",
    "НАЇЖУЮТЬСЯ",
    "НАЇЖУЮЧИ",
    "НАЇЖУЮЧИСЬ",
    "НАЇЖУЮЧИСЯ",
    "НАЇЗД",
    "НАЇЗДАМ",
    "НАЇЗДАМИ",
    "НАЇЗДАХ",
    "НАЇЗДЕ",
    "НАЇЗДИ",
    "НАЇЗДИВ",
    "НАЇЗДИВСЬ",
    "НАЇЗДИВСЯ",
    "НАЇЗДИВШИ",
    "НАЇЗДИВШИСЬ",
    "НАЇЗДИВШИСЯ",
    "НАЇЗДИЛА",
    "НАЇЗДИЛАСЬ",
    "НАЇЗДИЛАСЯ",
    "НАЇЗДИЛИ",
    "НАЇЗДИЛИСЬ",
    "НАЇЗДИЛИСЯ",
    "НАЇЗДИЛО",
    "НАЇЗДИЛОСЬ",
    "НАЇЗДИЛОСЯ",
    "НАЇЗДИМ",
    "НАЇЗДИМО",
    "НАЇЗДИМОСЬ",
    "НАЇЗДИМОСЯ",
    "НАЇЗДИМСЯ",
    "НАЇЗДИТЕ",
    "НАЇЗДИТЕСЬ",
    "НАЇЗДИТЕСЯ",
    "НАЇЗДИТИ",
    "НАЇЗДИТИМЕ",
    "НАЇЗДИТИМЕМ",
    "НАЇЗДИТИМЕМО",
    "НАЇЗДИТИМЕТЕ",
    "НАЇЗДИТИМЕШ",
    "НАЇЗДИТИМУ",
    "НАЇЗДИТИМУТЬ",
    "НАЇЗДИТИСЬ",
    "НАЇЗДИТИСЯ",
    "НАЇЗДИТЬ",
    "НАЇЗДИТЬСЯ",
    "НАЇЗДИШ",
    "НАЇЗДИШСЯ",
    "НАЇЗДІ",
    "НАЇЗДІВ",
    "НАЇЗДОВІ",
    "НАЇЗДОМ",
    "НАЇЗДУ",
    "НАЇЗДЯТЬ",
    "НАЇЗДЯТЬСЯ",
    "НАЇЗНИК",
    "НАЇЗНИКА",
    "НАЇЗНИКАМ",
    "НАЇЗНИКАМИ",
    "НАЇЗНИКАХ",
    "НАЇЗНИКИ",
    "НАЇЗНИКІВ",
    "НАЇЗНИКОВІ",
    "НАЇЗНИКОМ",
    "НАЇЗНИКУ",
    "НАЇЗНИЦЕ",
    "НАЇЗНИЦЕЮ",
    "НАЇЗНИЦІ",
    "НАЇЗНИЦТВА",
    "НАЇЗНИЦТВІ",
    "НАЇЗНИЦТВО",
    "НАЇЗНИЦТВОМ",
    "НАЇЗНИЦТВУ",
    "НАЇЗНИЦЬ",
    "НАЇЗНИЦЬКА",
    "НАЇЗНИЦЬКЕ",
    "НАЇЗНИЦЬКИЙ",
    "НАЇЗНИЦЬКИМ",
    "НАЇЗНИЦЬКИМИ",
    "НАЇЗНИЦЬКИХ",
    "НАЇЗНИЦЬКІ",
    "НАЇЗНИЦЬКІЙ",
    "НАЇЗНИЦЬКІМ",
    "НАЇЗНИЦЬКОГО",
    "НАЇЗНИЦЬКОЇ",
    "НАЇЗНИЦЬКОМУ",
    "НАЇЗНИЦЬКОЮ",
    "НАЇЗНИЦЬКУ",
    "НАЇЗНИЦЮ",
    "НАЇЗНИЦЯ",
    "НАЇЗНИЦЯМ",
    "НАЇЗНИЦЯМИ",
    "НАЇЗНИЦЯХ",
    "НАЇЛА",
    "НАЇЛАСЬ",
    "НАЇЛАСЯ",
    "НАЇЛИ",
    "НАЇЛИСЬ",
    "НАЇЛИСЯ",
    "НАЇЛО",
    "НАЇЛОСЬ",
    "НАЇЛОСЯ",
    "НАЇМ",
    "НАЇМО",
    "НАЇМОСЬ",
    "НАЇМОСЯ",
    "НАЇМСЯ",
    "НАЇСИ",
    "НАЇСИСЬ",
    "НАЇСИСЯ",
    "НАЇСТЕ",
    "НАЇСТЕСЬ",
    "НАЇСТЕСЯ",
    "НАЇСТИ",
    "НАЇСТИСЬ",
    "НАЇСТИСЯ",
    "НАЇСТЬ",
    "НАЇСТЬСЯ",
    "НАЇХАВ",
    "НАЇХАВШИ",
    "НАЇХАЛА",
    "НАЇХАЛИ",
    "НАЇХАЛО",
    "НАЇХАТИ",
    "НАЇХАТЬ",
]

IN_NAJ, OUT_NAJ = "НАЇ", "НАЙІ"


def get_revert_sqcq():
    data = EXCEPTIONS_SQCQ.copy()
    data.update({i.title(): o.title() for i, o in EXCEPTIONS_SQCQ.items()})
    data.update({i.lower(): o.lower() for i, o in EXCEPTIONS_SQCQ.items()})

    return replacer(data)


def get_revert_ji():
    data = {
        IN_NAJ: OUT_NAJ,
        IN_NAJ.title(): OUT_NAJ.title(),
        IN_NAJ.lower(): OUT_NAJ.lower(),
    }
    repl = replacer(data, count=1)

    def _(word):
        if word.word.upper() not in EXCEPTIONS_JI:
            word = repl(word)
        return word

    return _


convert = applier(get_revert_sqcq(), get_revert_ji())
